#version 330 core
struct PointLight
{
	vec3 position;
	vec3 diffuse;
	//attenuation
	float constant;
	float linear;
	float quadratic;
};
in vec3 FragmentPosition;
in vec2 TexCoords;
in vec3 Normals;

layout (location = 0) out vec3 gPosition;
layout (location = 1) out vec3 gNormal;
layout (location = 2) out vec4 gAlbedo;

#define NR_OF_POINT_LIGHTS 32
uniform sampler2D texture_diffuse;
uniform sampler2D texture_normal;
uniform samplerCube depthMap;
uniform PointLight pointlights[NR_OF_POINT_LIGHTS];
uniform float ambientTerm;
uniform int lightCount;

uniform float farPlane;
uniform mat4 view;

void main()
{    
    gAlbedo = vec4(texture(texture_diffuse, TexCoords));
	gNormal = (transpose(inverse(view)) * vec4(Normals, 1.0f)).xyz;
	gNormal = normalize(gNormal);
	gPosition = (view * vec4(FragmentPosition, 1.0f)).xyz;	
}
