#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec3 FragmentPosition;
out vec2 TexCoords;
out vec3 Normals;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main(){
    gl_Position = projection * view * model * vec4(position, 1.0f);
	FragmentPosition = vec3(model * vec4(position, 1.0f));
	Normals = normalize(mat3(transpose(inverse(model))) * normal);
	
	if(abs(Normals.x) > 0.5) {
		TexCoords = FragmentPosition.yz;
	} else if(abs(Normals.z) > 0.5) {
		TexCoords = FragmentPosition.xy;
	} else {
		TexCoords = FragmentPosition.xz;
	}	
	TexCoords *= 0.5;
}